<?php
/**
 * Emerald Payment Plugin by MintJoomla
 * a plugin for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldPaypaypal extends JPlugin
{

	var $_db = null;

	function plgEmeraldPaypaypal(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		parent::__construct($subject, $config);
	}

	function onAfterReceivePayment($post, $payment)
	{
		$processor = $post['processor'];
		if($processor != 'paypaypal') return false;
		$app = JFactory::getApplication();
		echo 'OK';
		$app->close();
	}

	function onReceivePayment(&$post)
	{
		
		if($post['processor'] != 'paypaypal') return 0;
		
		$params = new JRegistry($post['params']);
		$default = $this->params;
		
		$out['sid'] = $post['order_id'];
		$out['gateway'] = $post['processor'];
		$out['gateway_id'] = JRequest::getVar('tx', $post['txn_id']);
		$out['user_id'] = JRequest::getInt('cm', $post['custom']);
		$out['price'] = JRequest::getVar('amount', JRequest::getVar('mc_amount3', JRequest::getVar('mc_amount1', $post['mc_gross'])));
		$out['pay'] = $post['pay'];
		$out['email'] = $post['email'];
		
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n\n[Start get post]: " . print_r($post, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
		
		if($out['pay'] == 'ipn')
		{
			//$out = array();
			if(!jcsPPGetInfo($params, $post, $default))
			{
				echo "Not valid";
				JFactory::getApplication()->close();
			}
			
			if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[End get confirmed]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
			$database = JFactory::getDBO();
			switch($post['txn_type'])
			{
				case "subscr_signup":
					if(isset($post['mc_amount1']))
					{
						if($post['mc_amount1'] > 0) break;
						else
							$post['payment_status'] = 'Completed';
					}
				
				case "send_money":
				case "web_accept":
				case "subscr_payment":
					$out['user'] = $post['custom'];
					$out['gateway_id'] = trim($post['subscr_id'] . ' ' . $post['txn_id']);
					$out['price'] = ($post['mc_amount3'] ? $post['mc_amount3'] : ($post['mc_amount1'] ? $post['mc_amount1'] : $post['mc_gross']));
					switch($post['payment_status'])
					{
						case 'Processed':
						case 'Completed':
							$out['pay'] = 'success';
						break;
						
						case 'Refunded':
							$sql = "UPDATE #__jcs_user_subscr SET published = 0 WHERE gateway_id LIKE '" . ($post['subscr_id'] ? $post['subscr_id'] : $post['txn_id']) . "%'";
							$database->setQuery($sql);
							$database->query();
							return;
						break;
						
						case 'In-Progress':
						case 'Pending':
							$out['pay'] = 'fail';
						break;
						
						default:
							return;
					}
				break;
				
				//case 'recurring_payment':
				//break;
				

				case "subscr_failed":
					$out['user'] = $post['custom'];
					$out['gateway_id'] = $post['subscr_id'];
					$out['price'] = $post['mc_gross'];
					$out['pay'] = 'fail';
				break;
				
				case "subscr_eot":
				case "subscr_cancel":
					//$sql = "UPDATE #__jcs_user_subscr SET published = 0 WHERE gateway_id LIKE '{$post[subscr_id]}%'";
					//$database->setQuery($sql);
					//$database->query();
					return;
				break;
				case "new_case":
					$sql = "UPDATE #__jcs_user_subscr SET published = 0 WHERE gateway_id LIKE '" . ($post['subscr_id'] ? $post['subscr_id'] : $post['txn_id']) . "%'";
					$database->setQuery($sql);
					$database->query();
					return;
				break;
				
				case "adjustment":
					$sql = "UPDATE #__jcs_user_subscr SET published = 1 WHERE gateway_id LIKE '" . ($post['subscr_id'] ? $post['subscr_id'] : $post['txn_id']) . "%'";
					$database->setQuery($sql);
					$database->query();
					return;
				break;
				
				default:
					return;
			}
			//return $out;
		

		}
		
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Return ]: " . print_r($out, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
		
		return $out;
	}

	function onSendPayment(&$post)
	{
		if($post['processor'] != 'paypaypal') return false;
		$db = & JFactory::getDBO();
		
		$Itemid = @JRequest::getVar('Itemid');
		
		$params = new JRegistry($post['params']);
		$default = $this->params;
		
		$param['email'] = isset($post['email']) ? $post['email'] : '';
		$param['option'] = JRequest::getCmd('option');
		$param['task'] = @$post['task'];
		$param['view'] = @$post['view'];
		$param['layout'] = @$post['layout'];
		$param['processor'] = 'paypaypal';
		$param['order_id'] = @$post['order_id'];
		$param['amount'] = @floatval($post['order_amount']);
		
		$notify = '';
		if($params->get('params.paypaypal_ipn', $default->get('paypaypal_ipn')))
		{
			$return = urlencode(JURI::root() . 'index.php?option=' . $param['option'] . '&view=' . $param['view'] . '&layout=' . $param['layout'] . '&plan=' . $post['order_id'] . '&Itemid=' . $Itemid);
			$cancel_return = urlencode(JURI::root() . 'index.php?option=' . $param['option'] . '&view=' . $param['view'] . '&layout=' . $param['layout'] . '&Itemid=' . $Itemid);
			$notify = urlencode(JURI::base() . 'index.php?' . PPArray2Url($param) . '&pay=ipn');
			if($params->get('redirect'))
			{
				$url = (strstr($params->get('redirect'), 'http://')) ? $params->get('redirect') : JURI::root() . $params->get('redirect');
				$return = urlencode($url);
			}
			/*	if(EM_IDEV != '')
			{
					$return = urlencode(JURI::base() . 'index.php?' . PPArray2Url($param) . '&pay=ipn');
					$notify = urlencode(EM_IDEV.'/paypal_ipn_buynow.php');
			}*/
		
		}
		else
		{
			$param['Itemid'] = @$Itemid;
			$return = urlencode(JURI::base() . 'index.php?' . PPArray2Url($param) . '&pay=success');
			$cancel_return = urlencode(JURI::base() . 'index.php?' . PPArray2Url($param) . '&pay=fail');
		}
		
		unset($param);
		if($params->get('params.paypaypal_print_ipn', $default->get('paypaypal_print_ipn', 0)))
		{
			print "<pre>";
			print_r(urldecode($notify));
			print "</pre>";
			exit();
		}
		$param['notify_url'] = $notify;
		$param['return'] = $return;
		$param['cancel_return'] = $cancel_return;
		$param['lc'] = $params->get('params.paypaypal_lc', $default->get('paypaypal_lc', 'EN'));
		
		$param['no_shipping'] = $params->get('params.paypaypal_ship', $default->get('paypaypal_ship', 1));
		$param['amount'] = floatval($post['order_amount']);
		$param['cmd'] = "_xclick";
		$param['custom'] = $post['user_id'];
		
		$param['days_type'] = @$post['days_type'];
		$param['days'] = @$post['days'];
		$param['rm'] = "2";
		$param['item_name'] = urlencode($post['order_title']); // urlencode(str_replace(array('"', "'"), ' ', html_entity_decode($post['order_title'])));
		$param['charset'] = 'utf-8';
		
		$param['business'] = urlencode($params->get('params.paypaypal_email', $default->get('paypaypal_email')));
		$param['currency_code'] = $params->get('params.paypaypal_currency', $default->get('paypaypal_currency'));
		
		if($params->get('params.paypaypal_requre', $default->get('paypaypal_requre')))
		{
			unset($param['amount']);
			
			if(isset($post['a1']))
			{
				$param['a1'] = $post['order_amount'];
				$param['t1'] = strtoupper(substr($post['days_type'], 0, 1));
				$param['p1'] = $param['days'];
			}
			if($params->get('params.paypaypal_requre'))
			{
				if($params->get('params.paypaypal_initial_price') != '')
				{
					$param['a1'] = $params->get('params.paypaypal_initial_price');
				}
				if($params->get('params.paypaypal_initial_period') != '')
				{
					$param['t1'] = strtoupper($params->get('params.paypaypal_initial_period_type'));
					$param['p1'] = $params->get('params.paypaypal_initial_period');
				}
			}
			$param['cmd'] = "_xclick-subscriptions";
			$param['a3'] = $post['a3'] ? $post['a3'] : $post['order_amount'];
			$param['t3'] = strtoupper(substr($post['days_type'], 0, 1));
			$param['p3'] = $param['days'];
			$param['src'] = "1";
			$param['sra'] = "1";
			
			if($params->get('params.paypaypal_rec_times', '') != '')
			{
				$param['srt'] = intval($params->get('params.paypaypal_rec_times'));
			}
			
			$param['no_shipping'] = "2";
			$param['no_note'] = "1";
		
		}
		
		if($params->get('params.paypaypal_tax', $default->get('paypaypal_tax')))
		{
			$param['tax'] = $params->get('params.paypaypal_tax', $default->get('paypaypal_tax'));
		}
		if(! $param['business'] || ! $param['currency_code'] || ! $param['item_name'] || ! $post['order_amount'])
		{
			JError::raiseWarning(403, JText::_("Error Payment Processing: some of the params passed are empty"));
			return;
		}
		
		$url = 'https://www.paypal.com/us/cgi-bin/webscr?' . PPArray2Url($param);
		if($params->get('params.paypaypal_sandbox', $default->get('paypaypal_sandbox')))
		{
			$url = 'https://www.sandbox.paypal.com/cgi-bin/webscr?' . PPArray2Url($param);
		}
		
		header("location: $url");
	
	}

	function onCheckParams($params)
	{
		if($params->get('params.paypaypal_email') == '') JError::raiseNotice(100, $this->_name . ': ' . JText::_('PayPal Account (E-mail) is not set'));
		if($params->get('params.paypaypal_requre') && ! $params->get('params.paypaypal_ipn')) JError::raiseNotice(100, $this->_name . ': ' . JText::_('Use IPN (Requires for subscriptions) is not selected'));
	}

}

function jcsPPGetInfo($params, $post, $default)
{
	$_POST['cmd'] = '_notify-validate';
	
	$request = curl_init();
	curl_setopt_array($request, 
		array(
			CURLOPT_URL => 'https://www.' . ($params->get('params.paypaypal_sandbox', $default->get('paypaypal_sandbox')) ? 'sandbox.' : NULL) . 'paypal.com/cgi-bin/webscr', 
			CURLOPT_POST => 1, 
			CURLOPT_POSTFIELDS => http_build_query($_POST), 
			CURLOPT_RETURNTRANSFER => 1, 
			CURLOPT_HEADER => 0, 
			CURLOPT_SSL_VERIFYPEER => FALSE, 
			CURLOPT_CAINFO => 'cacert.pem', 
			CURLOPT_HTTPHEADER => array(
				"Content-Type: application/x-www-form-urlencoded", 
				"Content-Length: " . strlen(http_build_query($_POST))
			), 
			CURLOPT_TIMEOUT => 30
		));
	
	if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Send CURL]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
	
	$response = curl_exec($request);
	$status = curl_getinfo($request, CURLINFO_HTTP_CODE);
	curl_close($request);
	
	if(strpos($response, "VERIFIED") !== false)
	{
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log('transaction verified ' . $response . ' - ' . $post['txn_id'], 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
		return TRUE;
	}
	else
	{
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[transaction verification invalid]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
		return FALSE;
	}
	
	/*$req = 'cmd=_notify-validate';
	foreach($_POST as $key => $value)
	{
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
	}
	$header = "POST /cgi-bin/webscr HTTP/1.1\r\n";
	$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
	$header .= "Host: 'www.paypal.com\r\n";
	$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
	
	if($params->get('params.paypaypal_sandbox', $default->get('paypaypal_sandbox')))
	{
		$fp = fsockopen('www.sandbox.paypal.com', 80, $errno, $errstr, 30);
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Open socket Sandbox]", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
	
	}
	else
	{
		$fp = fsockopen('www.paypal.com', 80, $errno, $errstr, 30);
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Open socket]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
	
	}
	jimport('joomla.filesystem.file');
	if($fp)
	{
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Connected]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
		fputs($fp, $header . $req);
		while(! feof($fp))
		{
			$res = fgets($fp, 1024);
			
			if(strcmp($res, "VERIFIED") == 0)
			{
				
				if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n[Verified]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
				return $_POST;
			}
			else 
				if(strcmp($res, "INVALID") == 0)
				{
					if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n\n[Invalid]: " . print_r($res, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
				}
		
		}
		fclose($fp);
	}
	else
	{
		if($params->get('params.paypaypal_errorlog', $default->get('paypaypal_errorlog'))) error_log("\n\n[Connect Error]: " . $errno . $errstr, 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS . 'paypaypal' . DS . 'log.txt');
	}
	return false;
	*/
}

function PPArray2Url($param)
{
	foreach($param as $k => $v)
	{
		if(! $v) continue;
		$out[] = "$k=$v";
	}
	return implode('&', $out);
}
?>